<template>
  <div
    :class="{
      ...getElementCssClass('topWrapper'),
      ...getRootElementCSSClasses()
    }"
    @click.self="clickHandler"
  >
    <!-- Toggle -->
    <t-toggle
      ref="t-toggle"
      v-model="vModel"
      :variant="variant"
      :variants="style.variants"
      :classes="style.classes"
      :fixed-classes="style.fixedClasses"
      v-bind="{ ...toggleProps }"
    />
    <!--
      @slot Default slot
      @binding {Function} clickHandler - The click handler
      @binding {string} checkedPlaceholder - The checked placeholder
      @binding {string} uncheckedPlaceholder - The unchecked placeholder
      @binding {string} variant - The variant
    -->
    <slot
      :click-handler="clickHandler"
      :checked-placeholder="checkedPlaceholder"
      :unchecked-placeholder="uncheckedPlaceholder"
      :variant="variant"
    >
      <!-- Text -->
      <div
        class="flex items-center"
        @click.self="clickHandler"
      >
        {{ vModel ? checkedPlaceholder : uncheckedPlaceholder }}
      </div>
    </slot>
  </div>
</template>

<script>
// Mixins
import Variantable from '@/mixins/variantable'
import VModelable from '@/mixins/v-modelable'
import ExtractsCSSClasses from '@/mixins/extracts-css-classes'
// Style
import Style from './style'

/**
 * **VWrappedToggle** component
 */
export const VWrappedToggle = {
  name: 'VWrappedToggle',
  mixins: [
    Variantable,
    VModelable,
    ExtractsCSSClasses
  ],
  model: {
    // Emit also "changed" custom event on "input" emit
    mirrorEvents: [ 'changed' ]
  },
  props: {
    /**
     * value (to use v-model directive)
     * ⚠ must be initialized to prevent reactivity caveats
     */
    value: {
      type: Boolean,
      default: false
    },
    /**
     * The text to display in case of checked
     */
    checkedPlaceholder: {
      type: String,
      default () {
        return ''
      }
    },
    /**
     * The text to display in case of unchecked
     */
    uncheckedPlaceholder: {
      type: String,
      default () {
        return this.checkedPlaceholder
      }
    },
    /**
     * Where the toggle must be positioned ("right" or "left")
     */
    togglePosition: {
      type: String,
      default: 'left',
      validator: function (value) {
        // Si value est égale a left ou right
        if (value === 'left' || value === 'right') {
          return true
        }
        return false
      }
    }
  },
  computed: {
    /**
     * Get t-toggle props
     * @returns {object}
     */
    toggleProps: function () {
      return this.$attrs
    }
  },
  watch: {
    /**
     * Watch togglePosition to apply corresponding styles
     */
    togglePosition: function (to, from) {
      this.applyTogglePositionStyle()
    }
  },
  created () {
    this.applyTogglePositionStyle()
  },
  methods: {
    /**
     * Set toggle position based on togglePosition prop
     */
    applyTogglePositionStyle () {
      this.style.fixedClasses.topWrapper['flex-row-reverse'] = (this.togglePosition === 'right')
      this.style.fixedClasses.topWrapper['justify-between'] = (this.togglePosition === 'right')
    },
    /**
     * Handle click on wrapped toggle
     * @param {object} event The event payload
     * @returns {void}
     */
    clickHandler (event) {
      this.toggleVModel()
    },
    /**
     * Toggle v-model value by calling vue-tailwind t-toggle internal method
     */
    toggleVModel () {
      this.$refs['t-toggle'].toggleValue() // call internal method
    }
  },
  // Variantable options
  style: Style
}

export default VWrappedToggle
</script>
